/* Copyright 2004 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: testlevel.as,v 1.12 2004/11/09 21:04:12 tonic Exp $
 * $Revision: 1.12 $
 */

/* Note: playSound function is undocumented as it is currently
 *       only temporarily as it is.
 */

// Game executable version this script has been written for:
const int SCRIPT_GAME_VERSION = int(0x000400);

uint mTime;
int screenWidth, screenHeight;

UIFont *medFont, *smallFont;
uint medFontHeight, smallFontHeight;

PhysicsObject *objHead;
//target Objects
PhysicsObject *t1, *t2, *t3, *t4, *t5, *t6, *t7;

bool finished = false;
bool aborted = false;

// Called once on level initialization.
void onInit()
{
    requireGameVersion(SCRIPT_GAME_VERSION);
    screenWidth = getScreenWidth();
    screenHeight = getScreenHeight();
    medFont = getFont("medium");
    smallFont = getFont("small");
    medFontHeight = medFont->getFontHeight();
    smallFontHeight = smallFont->getFontHeight();

    objHead = findObject("Head");

	t1 = getObject(6);
	t2 = getObject(7);
	t3 = getObject(8);
	t4 = getObject(9);
	t5 = getObject(10);
	t6 = getObject(11);
	t7 = getObject(12);

}


// Called once for each game logic update before the physics update.
// Parameter 'time' is the simulation time in milliseconds.
void onUpdate(uint time)
{
	mTime = time;
	//Zero gravity is not possible - just emulate it :)
   	setGravity(0,0,float(-0.05 + randomDouble()/10 ));

	if( !aborted &&
		checkTargetPos(12, t1) &&
		checkTargetPos(12, t2) &&	
		checkTargetPos(12, t3) &&	
		checkTargetPos(12, t4) &&	
		checkTargetPos(12, t5) &&	
		checkTargetPos(12, t6) &&	
		checkTargetPos(12, t7) )
	{
		finished = true;
	}

	if( !finished && checkTargetPos(30, objHead) )
	{
		aborted = true;
	}

}

bool checkTargetPos(float sideLength, PhysicsObject *target)
{
	float x, y, z;
	target->getPosition(x, y, z);
	if( x < -sideLength || x > sideLength ||
		y < -sideLength || y > sideLength ||
		z < -sideLength || z > sideLength )
		return true;
	else
		return false;
}


// Called when there is a collision between the two given objects.
// Returns true to create contacts or false to ignore collision.
bool onCollision(PhysicsObject *o1, PhysicsObject *o2)
{
    
    // generate collision
    return true;
}


// Called when the game view is rendered.
// Might happen more or less frequently than update calls.
void onRender()
{
    if (mTime < 6000)
    {
        float x = float(screenWidth / 2);
        medFont->drawString(x, 100,
                            UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_BOTTOM,
                            "FooBox by mkl");
                            
	    smallFont->drawString(x, 130,UIFONT_ALIGN_HORIZ_CENTER, "You are in ZeroGravity (TM). Kick all colored boxes to the out of the large box!");
	    smallFont->drawString(x, 160,UIFONT_ALIGN_HORIZ_CENTER, "(either to the right or to the front, both counts)");
                            
                            
    }
	
    if (aborted)
        drawFailure();
    if (finished)
        drawVictory();

}

void drawFailure()
{
    medFont->drawString(float(screenWidth / 2), float(screenHeight / 2),
                        UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
                        "You Failed!");
}


void drawVictory()
{
    medFont->drawString(float(screenWidth / 2), float(screenHeight / 2),
                        UIFONT_ALIGN_HORIZ_CENTER | UIFONT_ALIGN_VERT_CENTER,
                        "Finished!");
}
